// This file is generated by kconfig_compiler from nntpresource.kcfg.
// All changes you do to this file will be lost.
#ifndef SETTINGSBASE_H
#define SETTINGSBASE_H

#include <kglobal.h>
#include <kconfigskeleton.h>
#include <kdebug.h>

class SettingsBase : public KConfigSkeleton
{
  public:
    enum EnumEncryption { None, SSL, TLS };

    SettingsBase( );
    ~SettingsBase();

    /**
      Set Server hostname
    */
    void setServer( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "Server" ) ))
        mServer = v;
    }

    /**
      Get Server hostname
    */
    QString server() const
    {
      return mServer;
    }

    /**
      Get Item object corresponding to Server()
    */
    ItemString *serverItem()
    {
      return mServerItem;
    }

    /**
      Set Server port number
    */
    void setPort( uint v )
    {
      if (!isImmutable( QString::fromLatin1( "Port" ) ))
        mPort = v;
    }

    /**
      Get Server port number
    */
    uint port() const
    {
      return mPort;
    }

    /**
      Get Item object corresponding to Port()
    */
    ItemUInt *portItem()
    {
      return mPortItem;
    }

    /**
      Set Encryption method
    */
    void setEncryption( int v )
    {
      if (!isImmutable( QString::fromLatin1( "Encryption" ) ))
        mEncryption = v;
    }

    /**
      Get Encryption method
    */
    int encryption() const
    {
      return mEncryption;
    }

    /**
      Get Item object corresponding to Encryption()
    */
    ItemEnum *encryptionItem()
    {
      return mEncryptionItem;
    }

    /**
      Set Account name
    */
    void setName( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "Name" ) ))
        mName = v;
    }

    /**
      Get Account name
    */
    QString name() const
    {
      return mName;
    }

    /**
      Get Item object corresponding to Name()
    */
    ItemString *nameItem()
    {
      return mNameItem;
    }

    /**
      Set Server requires login
    */
    void setRequiresAuthentication( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "RequiresAuthentication" ) ))
        mRequiresAuthentication = v;
    }

    /**
      Get Server requires login
    */
    bool requiresAuthentication() const
    {
      return mRequiresAuthentication;
    }

    /**
      Get Item object corresponding to RequiresAuthentication()
    */
    ItemBool *requiresAuthenticationItem()
    {
      return mRequiresAuthenticationItem;
    }

    /**
      Set Username for login
    */
    void setUserName( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "UserName" ) ))
        mUserName = v;
    }

    /**
      Get Username for login
    */
    QString userName() const
    {
      return mUserName;
    }

    /**
      Get Item object corresponding to UserName()
    */
    ItemString *userNameItem()
    {
      return mUserNameItem;
    }

    /**
      Set Store login password in KWallet
    */
    void setStorePassword( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "StorePassword" ) ))
        mStorePassword = v;
    }

    /**
      Get Store login password in KWallet
    */
    bool storePassword() const
    {
      return mStorePassword;
    }

    /**
      Get Item object corresponding to StorePassword()
    */
    ItemBool *storePasswordItem()
    {
      return mStorePasswordItem;
    }

    /**
      Set Maximum number of articles to download.
    */
    void setMaxDownload( uint v )
    {
      if (!isImmutable( QString::fromLatin1( "MaxDownload" ) ))
        mMaxDownload = v;
    }

    /**
      Get Maximum number of articles to download.
    */
    uint maxDownload() const
    {
      return mMaxDownload;
    }

    /**
      Get Item object corresponding to MaxDownload()
    */
    ItemUInt *maxDownloadItem()
    {
      return mMaxDownloadItem;
    }

    /**
      Set Allow local modifications of the news group hierarchy
    */
    void setLocalHierarchy( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "LocalHierarchy" ) ))
        mLocalHierarchy = v;
    }

    /**
      Get Allow local modifications of the news group hierarchy
    */
    bool localHierarchy() const
    {
      return mLocalHierarchy;
    }

    /**
      Get Item object corresponding to LocalHierarchy()
    */
    ItemBool *localHierarchyItem()
    {
      return mLocalHierarchyItem;
    }

    /**
      Set Create newsgroups in a flat hierarchy by default
    */
    void setFlatHierarchy( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "FlatHierarchy" ) ))
        mFlatHierarchy = v;
    }

    /**
      Get Create newsgroups in a flat hierarchy by default
    */
    bool flatHierarchy() const
    {
      return mFlatHierarchy;
    }

    /**
      Get Item object corresponding to FlatHierarchy()
    */
    ItemBool *flatHierarchyItem()
    {
      return mFlatHierarchyItem;
    }

    /**
      Set Allow local renaming of newsgroups
    */
    void setLocalNames( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "LocalNames" ) ))
        mLocalNames = v;
    }

    /**
      Get Allow local renaming of newsgroups
    */
    bool localNames() const
    {
      return mLocalNames;
    }

    /**
      Get Item object corresponding to LocalNames()
    */
    ItemBool *localNamesItem()
    {
      return mLocalNamesItem;
    }

    /**
      Set Last update of the newsgroup list
    */
    void setLastGroupList( const QDateTime & v )
    {
      if (!isImmutable( QString::fromLatin1( "LastGroupList" ) ))
        mLastGroupList = v;
    }

    /**
      Get Last update of the newsgroup list
    */
    QDateTime lastGroupList() const
    {
      return mLastGroupList;
    }

    /**
      Get Item object corresponding to LastGroupList()
    */
    ItemDateTime *lastGroupListItem()
    {
      return mLastGroupListItem;
    }

  protected:

    // Account
    QString mServer;
    uint mPort;
    int mEncryption;
    QString mName;
    bool mRequiresAuthentication;
    QString mUserName;
    bool mStorePassword;

    // Articles
    uint mMaxDownload;

    // Newsgroups
    bool mLocalHierarchy;
    bool mFlatHierarchy;
    bool mLocalNames;

    // Internal
    QDateTime mLastGroupList;

  private:
    ItemString *mServerItem;
    ItemUInt *mPortItem;
    ItemEnum *mEncryptionItem;
    ItemString *mNameItem;
    ItemBool *mRequiresAuthenticationItem;
    ItemString *mUserNameItem;
    ItemBool *mStorePasswordItem;
    ItemUInt *mMaxDownloadItem;
    ItemBool *mLocalHierarchyItem;
    ItemBool *mFlatHierarchyItem;
    ItemBool *mLocalNamesItem;
    ItemDateTime *mLastGroupListItem;
};

#endif

